import { system, world } from '@minecraft/server';


system.runTimeout(() => {
    world.getDimension('overworld').runCommandAsync("scoreboard objectives add idelete dummy idelete");
}, 1);


system.runInterval(() => {
    const overworld = world.getDimension('overworld');

    
    overworld.runCommandAsync('scoreboard players set @e[type=item,tag=!idelete] idelete 0');


    overworld.runCommandAsync('scoreboard players add @e[type=item,tag=idelete] idelete 1');
    
    overworld.runCommandAsync('tag @e[type=item,tag=!idelete] add idelete');

    overworld.runCommandAsync('tag @e[type=item,tag=nidelete] remove idelete');


    overworld.runCommandAsync('kill @e[type=item,scores={idelete=180}]');
}, 20);




world.afterEvents.entityDie.subscribe((event) => {
  const entity = event.deadEntity;

  if (entity.typeId === "minecraft:player") {
    try {
      const { x, y, z } = entity.location;
      const command = `tag @e[type=item,x=${x},y=${y},z=${z},r=10] add nidelete`;
      world.getDimension('overworld').runCommandAsync(command);
    } catch (error) {
      console.warn("Error applying regeneration on death:", error);
    }
  }
});
