import { world, system } from "@minecraft/server";


let blockWId = null; 


world.beforeEvents.playerInteractWithBlock.subscribe(({ block, player, itemStack }) => {
    try {
        
        if (itemStack?.typeId === "zc:pbw") {
            
            blockWId = block.typeId;
            player.sendMessage(`§aSelected block: ${blockWId}`);
        }
    } catch (error) {
        console.warn("Error during block interaction:", error);
    }
});


world.afterEvents.itemUse.subscribe(({ source: player, itemStack }) => {
    try {
        
        if (itemStack?.typeId === "zc:pbw") {
            if (blockWId) {
                
                const { x, y, z } = player.location;
                const direction = player.getViewDirection(); 

                
                const startX = Math.floor(x + direction.x * -1);
                const startY = Math.floor(y - 1);
                const startZ = Math.floor(z + direction.z * -1);

                const endX = Math.floor(x + direction.x * 7);
                const endY = Math.floor(y - 1);
                const endZ = Math.floor(z + direction.z * 7);

                
                const fillVolume = Math.abs(endX - startX + 1) * Math.abs(endY - startY + 1) * Math.abs(endZ - startZ + 1);

                
                const inventory = player.getComponent("minecraft:inventory").container;
                let availableBlocks = 0;

                
                for (let i = 0; i < inventory.size; i++) {
                    const slot = inventory.getItem(i);
                    if (slot && slot.typeId === blockWId) {
                        availableBlocks += slot.amount;
                    }
                }

                if (availableBlocks >= fillVolume) {
                    
                    const command = `fill ${startX} ${startY} ${startZ} ${endX} ${endY} ${endZ} ${blockWId} replace air`;
                    player.runCommandAsync(command);

                    
                    let blocksToRemove = fillVolume;
                    for (let i = 0; i < inventory.size; i++) {
                        const slot = inventory.getItem(i);
                        if (slot && slot.typeId === blockWId) {
                            if (slot.amount > blocksToRemove) {
                                slot.amount -= blocksToRemove;
                                inventory.setItem(i, slot);
                                break;
                            } else {
                                blocksToRemove -= slot.amount;
                                inventory.setItem(i, null);
                            }
                        }
                    }
                } else {
                    
                    player.sendMessage("§cNot enough blocks in your inventory to fill this area!");
                }
            } else {
                player.sendMessage("§cNo block has been selected yet!");
            }
        }
    } catch (error) {
        console.warn("Error executing builder wand logic:", error);
    }
});
