import { world, system } from "@minecraft/server";

world.afterEvents.playerPlaceBlock.subscribe(async (event) => {
    const player = event.player; 
    const block = event.block;
    const blockPos = block.location;

    if (block.typeId === "zc:aetb") {
        try {
            await player.runCommandAsync(`summon zc:advance_enchantment_book ${blockPos.x} ${blockPos.y + 1} ${blockPos.z}`);
        } catch (error) {
            console.error(`Failed to summon entity: ${error}`);
        }
    }
});






function mainTick() {

  world.getDimension("overworld").runCommand(
    "execute @e[type=zc:advance_enchantment_book] ~ ~ ~ detect ~ ~-1 ~ air 0 tp @s 0 -80 0"
  );


  if (system.currentTick % 100 === 0) {
    world.getDimension("overworld").runCommand("kill @e[x=0,y=-80,z=0,r=0.8]");
  }


  system.run(mainTick);
}

system.run(mainTick);
