import { world, ItemStack, ScoreboardIdentityType } from "@minecraft/server";
import { ActionFormData, ModalFormData } from "@minecraft/server-ui";

// Shop items
const shopItems = [
    { id: "minecraft:cobblestone", name: "Cobblestone", icon: "textures/blocks/cobblestone.png", buyCost: 1, sellPrice: 1 },
        { id: "minecraft:dirt", name: "Dirt", icon: "textures/blocks/dirt.png", buyCost: 1, sellPrice: 1 },
        { id: "minecraft:sand", name: "Sand", icon: "textures/blocks/sand.png", buyCost: 1, sellPrice: 1 },
        { id: "minecraft:gravel", name: "Gravel", icon: "textures/blocks/gravel.png", buyCost: 1, sellPrice: 1 },
        { id: "minecraft:glass", name: "Glass", icon: "textures/blocks/glass.png", buyCost: 2, sellPrice: 1 },
        { id: "minecraft:brick_block", name: "Bricks", icon: "textures/blocks/brick.png", buyCost: 4, sellPrice: 2 },
        { id: "minecraft:oak_log", name: "Oak Log", icon: "textures/blocks/log_oak.png", buyCost: 2, sellPrice: 1 },
        { id: "minecraft:planks", name: "Oak Planks", icon: "textures/blocks/planks_oak.png", buyCost: 1, sellPrice: 1 },
        { id: "minecraft:obsidian", name: "Obsidian", icon: "textures/blocks/obsidian.png", buyCost: 10, sellPrice: 8 },
        { id: "minecraft:gold_block", name: "Gold Block", icon: "textures/blocks/gold_block.png", buyCost: 180, sellPrice: 135 },
        { id: "minecraft:nether_bricks", name: "Nether Bricks", icon: "textures/blocks/nether_brick.png", buyCost: 6, sellPrice: 3 },
        { id: "minecraft:stone", name: "Stone", icon: "textures/blocks/stone.png", buyCost: 1, sellPrice: 1 },
    { id: "minecraft:deepslate", name: "Deepslate", icon: "textures/blocks/deepslate/deepslate.png", buyCost: 2, sellPrice: 1 },
    { id: "minecraft:tuff", name: "Tuff", icon: "textures/blocks/tuff.png", buyCost: 2, sellPrice: 1 },
    { id: "minecraft:calcite", name: "Calcite", icon: "textures/blocks/calcite.png", buyCost: 3, sellPrice: 2 },
    { id: "minecraft:dripstone_block", name: "Dripstone Block", icon: "textures/blocks/dripstone_block.png", buyCost: 3, sellPrice: 2 },
    { id: "minecraft:raw_copper", name: "Raw Copper", icon: "textures/items/raw_copper.png", buyCost: 4, sellPrice: 2 },
    { id: "minecraft:basalt", name: "Basalt", icon: "textures/blocks/basalt_side.png", buyCost: 2, sellPrice: 1 },
    { id: "minecraft:raw_iron", name: "Raw Iron", icon: "textures/items/raw_iron.png", buyCost: 5, sellPrice: 3 },
    { id: "minecraft:mossy_cobblestone", name: "Mossy Cobblestone", icon: "textures/blocks/cobblestone_mossy.png", buyCost: 2, sellPrice: 1 },
    { id: "minecraft:moss_block", name: "Moss Block", icon: "textures/blocks/moss_block.png", buyCost: 3, sellPrice: 2 },
    { id: "minecraft:rotten_flesh", name: "Rotten Flesh", icon: "textures/items/rotten_flesh.png", buyCost: 3, sellPrice: 2 },
        { id: "minecraft:stone", name: "Stone", icon: "textures/blocks/stone.png", buyCost: 2, sellPrice: 1 },
        { id: "minecraft:smooth_stone", name: "Smooth Stone", icon: "textures/blocks/stone_slab_top.png", buyCost: 3, sellPrice: 2 },
        { id: "minecraft:granite", name: "Granite", icon: "textures/blocks/stone_granite.png", buyCost: 2, sellPrice: 1 },
        { id: "minecraft:polished_granite", name: "Polished Granite", icon: "textures/blocks/stone_granite_smooth.png", buyCost: 3, sellPrice: 2 },
        { id: "minecraft:andesite", name: "Andesite", icon: "textures/blocks/stone_andesite.png", buyCost: 2, sellPrice: 1 },
        { id: "minecraft:polished_andesite", name: "Polished Andesite", icon: "textures/blocks/stone_andesite_smooth.png", buyCost: 3, sellPrice: 2 },
        { id: "minecraft:diorite", name: "Diorite", icon: "textures/blocks/stone_diorite.png", buyCost: 2, sellPrice: 1 },
        { id: "minecraft:polished_diorite", name: "Polished Diorite", icon: "textures/blocks/stone_diorite_smooth.png", buyCost: 3, sellPrice: 2 },
        { id: "minecraft:quartz_block", name: "Quartz Block", icon: "textures/blocks/quartz_block_top.png", buyCost: 8, sellPrice: 5 },
        { id: "minecraft:chiseled_quartz_block", name: "Chiseled Quartz Block", icon: "textures/blocks/quartz_block_chiseled.png", buyCost: 10, sellPrice: 6 },
        { id: "minecraft:red_sand", name: "Red Sand", icon: "textures/blocks/red_sand.png", buyCost: 3, sellPrice: 1 },
        { id: "minecraft:stone_bricks", name: "Stone Bricks", icon: "textures/blocks/stonebrick.png", buyCost: 4, sellPrice: 2 },
        { id: "minecraft:bread", name: "Bread", icon: "textures/items/bread.png", buyCost: 5, sellPrice: 2 },
        { id: "minecraft:apple", name: "Apple", icon: "textures/items/apple.png", buyCost: 4, sellPrice: 2 },
        { id: "minecraft:carrot", name: "Carrot", icon: "textures/items/carrot.png", buyCost: 3, sellPrice: 1 },
        { id: "minecraft:potato", name: "Potato", icon: "textures/items/potato.png", buyCost: 3, sellPrice: 1 },
        { id: "minecraft:sweet_berries", name: "Sweet Berries", icon: "textures/items/sweet_berries.png", buyCost: 4, sellPrice: 2 },
        { id: "minecraft:cake", name: "Cake", icon: "textures/items/cake.png", buyCost: 15, sellPrice: 5 },
        { id: "minecraft:pumpkin_pie", name: "Pumpkin Pie", icon: "textures/items/pumpkin_pie.png", buyCost: 7, sellPrice: 3 },
        { id: "minecraft:glow_berries", name: "Glow Berries", icon: "textures/items/glow_berries.png", buyCost: 5, sellPrice: 3 },
        { id: "minecraft:dried_kelp", name: "Dried Kelp", icon: "textures/items/dried_kelp.png", buyCost: 3, sellPrice: 1 },
        { id: "minecraft:beetroot_soup", name: "Beetroot Soup", icon: "textures/items/beetroot_soup.png", buyCost: 5, sellPrice: 2 },
        { id: "minecraft:coal", name: "Coal", icon: "textures/items/coal.png", buyCost: 2, sellPrice: 1 },
        { id: "minecraft:iron_ingot", name: "Iron Ingot", icon: "textures/items/iron_ingot.png", buyCost: 5, sellPrice: 3 },
        { id: "minecraft:torch", name: "Torch", icon: "textures/blocks/torch_on.png", buyCost: 2, sellPrice: 1 },
        { id: "minecraft:blaze_rod", name: "Blaze Rod", icon: "textures/items/blaze_rod.png", buyCost: 10, sellPrice: 5 },
        { id: "minecraft:string", name: "String", icon: "textures/items/string.png", buyCost: 2, sellPrice: 1 },
       { id: "minecraft:bone", name: "Bone", icon: "textures/items/bone.png", buyCost: 3, sellPrice: 1 },
       { id: "minecraft:flint", name: "Flint", icon: "textures/items/flint.png", buyCost: 2, sellPrice: 1 },
       { id: "minecraft:feather", name: "Feather", icon: "textures/items/feather.png", buyCost: 2, sellPrice: 1 },
       { id: "minecraft:gunpowder", name: "Gunpowder", icon: "textures/items/gunpowder.png", buyCost: 4, sellPrice: 2 },
        { id: "minecraft:gold_ingot", name: "Gold Ingot", icon: "textures/items/gold_ingot.png", buyCost: 20, sellPrice: 15 },
        { id: "minecraft:wind_charge", name: "Wind Charge", icon: "textures/items/wind_charge.png", buyCost: 80, sellPrice: 70 },
        { id: "minecraft:diamond", name: "Diamond", icon: "textures/items/diamond.png", buyCost: 90, sellPrice: 40 },
        { id: "minecraft:emerald", name: "Emerald", icon: "textures/items/emerald.png", buyCost: 60, sellPrice: 40 },
        { id: "minecraft:amethyst_shard", name: "Amethyst Shard", icon: "textures/items/amethyst_shard.png", buyCost: 10, sellPrice: 5 },
         { id: "minecraft:prismarine_shard", name: "Prismarine Shard", icon: "textures/items/prismarine_shard.png", buyCost: 25, sellPrice: 15 },
        { id: "minecraft:heart_of_the_sea", name: "Heart of the Sea", icon: "textures/items/heartofthesea_closed.png", buyCost: 50, sellPrice: 40 },
        { id: "minecraft:recovery_compass", name: "Recovery Compass", icon: "textures/items/recovery_compass_item.png", buyCost: 50, sellPrice: 40 },
       { id: "minecraft:sea_lantern", name: "Sea Lantern", icon: "textures/blocks/beacon.png", buyCost: 20, sellPrice: 15 },
       { id: "minecraft:anvil", name: "Anvil", icon: "textures/blocks/anvil_base.png", buyCost: 40, sellPrice: 25 },
           { id: "minecraft:netherite_ingot", name: "Netherite Ingot", icon: "textures/items/netherite_ingot.png", buyCost: 1000, sellPrice: 750 },
    { id: "minecraft:ancient_debris", name: "Ancient Debris", icon: "textures/blocks/ancient_debris_side.png", buyCost: 280, sellPrice: 190 },
    { id: "minecraft:lodestone", name: "Lodestone", icon: "textures/blocks/lodestone_side.png", buyCost: 80, sellPrice: 60 },
    { id: "minecraft:crying_obsidian", name: "Crying Obsidian", icon: "textures/blocks/crying_obsidian.png", buyCost: 15, sellPrice: 10 },
    { id: "minecraft:honeycomb", name: "Honeycomb", icon: "textures/items/honeycomb.png", buyCost: 10, sellPrice: 8 },
    { id: "minecraft:slime_ball", name: "Slime Ball", icon: "textures/items/slimeball.png", buyCost: 3, sellPrice: 1 },
    { id: "minecraft:trident", name: "Trident", icon: "textures/items/trident.png", buyCost: 450, sellPrice: 200 },
    { id: "minecraft:phantom_membrane", name: "Phantom Membrane", icon: "textures/items/phantom_membrane.png", buyCost: 20, sellPrice: 15 },
    { id: "minecraft:shulker_shell", name: "Shulker Shell", icon: "textures/items/shulker_shell.png", buyCost: 50, sellPrice: 40 },
    { id: "minecraft:beacon", name: "Beacon", icon: "textures/blocks/beacon.png", buyCost: 200, sellPrice: 150 },
    { id: "minecraft:end_crystal", name: "End Crystal", icon: "textures/items/end_crystal.png", buyCost: 250, sellPrice: 200 },
    { id: "minecraft:nether_star", name: "Nether Star", icon: "textures/items/nether_star.png", buyCost: 5000, sellPrice: 1000 },
    { id: "minecraft:turtle_egg", name: "Turtle Egg", icon: "textures/items/turtle_egg.png", buyCost: 30, sellPrice: 20 },
    { id: "minecraft:chain", name: "Chain", icon: "textures/items/chain.png", buyCost: 8, sellPrice: 5 },
    { id: "minecraft:elytra", name: "Elytra", icon: "textures/items/elytra.png", buyCost: 8000, sellPrice: 200 },
    { id: "minecraft:amethyst_block", name: "Amethyst Block", icon: "textures/blocks/amethyst_block.png", buyCost: 12, sellPrice: 8 },
    { id: "minecraft:copper_block", name: "Copper Block", icon: "textures/blocks/copper_block.png", buyCost: 15, sellPrice: 10 },
    { id: "minecraft:redstone", name: "Redstone Dust", icon: "textures/items/redstone_dust.png", buyCost: 5, sellPrice: 3 },
    { id: "minecraft:copper_ingot", name: "Copper Ingot", icon: "textures/items/copper_ingot.png", buyCost: 6, sellPrice: 4 },
    { id: "minecraft:lapis_lazuli", name: "Lapis Lazuli", icon: "textures/items/dye_powder_blue.png", buyCost: 4, sellPrice: 2 },
    { id: "minecraft:wheat_seeds", name: "Wheat Seeds", icon: "textures/items/seeds_wheat.png", buyCost: 2, sellPrice: 1 },
    { id: "minecraft:melon_seeds", name: "Melon Seeds", icon: "textures/items/seeds_melon.png", buyCost: 3, sellPrice: 2 },
    { id: "minecraft:pumpkin_seeds", name: "Pumpkin Seeds", icon: "textures/items/seeds_pumpkin.png", buyCost: 3, sellPrice: 2 },
    { id: "minecraft:white_wool", name: "White Wool", icon: "textures/blocks/wool_colored_white.png", buyCost: 4, sellPrice: 2 },
    { id: "minecraft:glowstone", name: "Glowstone", icon: "textures/blocks/glowstone.png", buyCost: 8, sellPrice: 5 },
    { id: "minecraft:glowstone_dust", name: "Glowstone Dust", icon: "textures/items/glowstone_dust.png", buyCost: 4, sellPrice: 2 },
    { id: "minecraft:book", name: "Book", icon: "textures/items/book_normal.png", buyCost: 6, sellPrice: 3 },
    { id: "minecraft:paper", name: "Paper", icon: "textures/items/paper.png", buyCost: 2, sellPrice: 1 },
    { id: "minecraft:sugar_cane", name: "Sugar Cane", icon: "textures/items/reeds.png", buyCost: 3, sellPrice: 2 },
    { id: "minecraft:sugar", name: "Sugar", icon: "textures/items/sugar.png", buyCost: 2, sellPrice: 1 },
    { id: "minecraft:cobbled_deepslate", name: "Deepslate", icon: "textures/blocks/deepslate/cobbled_deepslate.png", buyCost: 3, sellPrice: 2 },
    { id: "minecraft:polished_deepslate", name: "Polished Deepslate", icon: "textures/blocks/deepslate/polished_deepslate.png", buyCost: 4, sellPrice: 2 },
    { id: "minecraft:deepslate_bricks", name: "Deepslate Bricks", icon: "textures/blocks/deepslate/deepslate_bricks.png", buyCost: 5, sellPrice: 3 },
    { id: "minecraft:deepslate_tiles", name: "Deepslate Tiles", icon: "textures/blocks/deepslate/deepslate_tiles.png", buyCost: 6, sellPrice: 4 },
    { id: "minecraft:smooth_basalt", name: "Smooth Basalt", icon: "textures/blocks/smooth_basalt.png", buyCost: 3, sellPrice: 2 },
    { id: "minecraft:blackstone", name: "Blackstone", icon: "textures/blocks/blackstone.png", buyCost: 4, sellPrice: 2 },
    { id: "minecraft:polished_blackstone", name: "Polished Blackstone", icon: "textures/blocks/polished_blackstone.png", buyCost: 5, sellPrice: 3 },
    { id: "minecraft:grindstone", name: "Grindstone", icon: "textures/blocks/grindstone_side.tga", buyCost: 10, sellPrice: 6 },
    { id: "minecraft:sandstone", name: "Sandstone", icon: "textures/blocks/sandstone_normal.png", buyCost: 3, sellPrice: 2 },
    { id: "minecraft:smooth_sandstone", name: "Smooth Sandstone", icon: "textures/blocks/sandstone_smooth.png", buyCost: 4, sellPrice: 2 },
    { id: "minecraft:quartz_block", name: "Quartz Block", icon: "textures/blocks/quartz_block_top.png", buyCost: 8, sellPrice: 5 },
    { id: "minecraft:smooth_quartz", name: "Smooth Quartz", icon: "textures/blocks/quartz_block_top.png", buyCost: 9, sellPrice: 6 },
    { id: "minecraft:bamboo", name: "Bamboo", icon: "textures/items/bamboo.png", buyCost: 4, sellPrice: 3 },
    { id: "minecraft:ice", name: "Ice", icon: "textures/blocks/ice.png", buyCost: 2, sellPrice: 1 },
{ id: "minecraft:packed_ice", name: "Packed Ice", icon: "textures/blocks/ice_packed.png", buyCost: 5, sellPrice: 3 },
{ id: "minecraft:blue_ice", name: "Blue Ice", icon: "textures/blocks/blue_ice.png", buyCost: 10, sellPrice: 5 },
{ id: "minecraft:kelp", name: "Kelp", icon: "textures/items/kelp.png", buyCost: 2, sellPrice: 1 },
{ id: "minecraft:sponge", name: "Sponge", icon: "textures/blocks/sponge.png", buyCost: 30, sellPrice: 20 },
{ id: "minecraft:scaffolding", name: "Scaffolding", icon: "textures/blocks/scaffolding_top.tga", buyCost: 3, sellPrice: 2 },
{ id: "minecraft:end_stone", name: "End Stone", icon: "textures/blocks/end_stone.png", buyCost: 5, sellPrice: 3 },
{ id: "minecraft:end_rod", name: "End Rod", icon: "textures/blocks/end_rod.png", buyCost: 8, sellPrice: 5 },
{ id: "minecraft:chorus_fruit", name: "Chorus Fruit", icon: "textures/items/chorus_fruit.png", buyCost: 6, sellPrice: 3 },
{ id: "minecraft:piston", name: "Piston", icon: "textures/blocks/piston_top_normal.png", buyCost: 10, sellPrice: 7 },
{ id: "minecraft:sticky_piston", name: "Sticky Piston", icon: "textures/blocks/piston_top_sticky.png", buyCost: 12, sellPrice: 8 },
{ id: "minecraft:observer", name: "Observer", icon: "textures/blocks/observer_front.png", buyCost: 15, sellPrice: 10 },
{ id: "minecraft:hopper", name: "Hopper", icon: "textures/blocks/hopper_top.png", buyCost: 25, sellPrice: 15 },
{ id: "minecraft:comparator", name: "Redstone Comparator", icon: "textures/blocks/comparator_on.png", buyCost: 10, sellPrice: 6 },
{ id: "minecraft:repeater", name: "Redstone Repeater", icon: "textures/blocks/repeater_on.png", buyCost: 8, sellPrice: 5 },
{ id: "minecraft:redstone_block", name: "Redstone Block", icon: "textures/blocks/redstone_block.png", buyCost: 12, sellPrice: 8 },
{ id: "minecraft:barrel", name: "Barrel", icon: "textures/blocks/barrel_side.png", buyCost: 6, sellPrice: 3 },
{ id: "minecraft:lectern", name: "Lectern", icon: "textures/blocks/lectern_top.png", buyCost: 10, sellPrice: 5 },
{ id: "minecraft:campfire", name: "Campfire", icon: "textures/blocks/campfire_log_lit.png", buyCost: 8, sellPrice: 5 },
{ id: "minecraft:smithing_table", name: "Smithing Table", icon: "textures/blocks/smithing_table_top.png", buyCost: 15, sellPrice: 10 },
{ id: "minecraft:blast_furnace", name: "Blast Furnace", icon: "textures/blocks/blast_furnace_front_on.png", buyCost: 20, sellPrice: 15 },
{ id: "minecraft:smoker", name: "Smoker", icon: "textures/blocks/smoker_front_on.png", buyCost: 12, sellPrice: 8 },
{ id: "minecraft:fletching_table", name: "Fletching Table", icon: "textures/blocks/fletcher_table_side1.png", buyCost: 10, sellPrice: 6 },
{ id: "minecraft:loom", name: "Loom", icon: "textures/blocks/loom_top.png", buyCost: 8, sellPrice: 5 },
{ id: "minecraft:cartography_table", name: "Cartography Table", icon: "textures/blocks/cartography_table_top.png", buyCost: 8, sellPrice: 5 },
{ id: "minecraft:beehive", name: "Beehive", icon: "textures/blocks/beehive_side.png", buyCost: 25, sellPrice: 15 },
{ id: "minecraft:cauldron", name: "Cauldron", icon: "textures/blocks/cauldron_side.png", buyCost: 20, sellPrice: 10 },
{ id: "minecraft:bucket", name: "Bucket", icon: "textures/items/bucket_empty.png", buyCost: 12, sellPrice: 8 },
{ id: "minecraft:lava_bucket", name: "Lava Bucket", icon: "textures/items/bucket_lava.png", buyCost: 20, sellPrice: 10 },
{ id: "minecraft:water_bucket", name: "Water Bucket", icon: "textures/items/bucket_water.png", buyCost: 15, sellPrice: 8 },
{ id: "minecraft:milk_bucket", name: "Milk Bucket", icon: "textures/items/bucket_milk.png", buyCost: 15, sellPrice: 8 },
{ id: "minecraft:snowball", name: "Snowball", icon: "textures/items/snowball.png", buyCost: 3, sellPrice: 1 },
{ id: "minecraft:nether_wart", name: "Nether Wart", icon: "textures/items/nether_wart.png", buyCost: 8, sellPrice: 4 },
{ id: "minecraft:warped_stem", name: "Warped Stem", icon: "textures/blocks/huge_fungus/warped_stem_top.png", buyCost: 3, sellPrice: 2 },
{ id: "minecraft:crimson_stem", name: "Crimson Stem", icon: "textures/blocks/huge_fungus/crimson_stem_top.png", buyCost: 3, sellPrice: 2 },
{ id: "minecraft:respawn_anchor", name: "Respawn Anchor", icon: "textures/blocks/respawn_anchor_top.png", buyCost: 100, sellPrice: 60 },
{ id: "minecraft:turtle_egg", name: "Turtle Egg", icon: "textures/items/turtle_egg.png", buyCost: 20, sellPrice: 10 },
{ id: "minecraft:crying_obsidian", name: "Crying Obsidian", icon: "textures/blocks/crying_obsidian.png", buyCost: 15, sellPrice: 10 },
{ id: "minecraft:pointed_dripstone", name: "Pointed Dripstone", icon: "textures/blocks/pointed_dripstone_down_tip.png", buyCost: 2, sellPrice: 1 }
];

function getPlayerScore(player, objective) {
    const scoreboard = world.scoreboard.getObjective(objective);
    const identity = scoreboard.getParticipants().find(p => p.type === ScoreboardIdentityType.Player && p.displayName === player.name);
    return identity ? scoreboard.getScore(identity) : 0;
}

function addZMC(player, amount) {
    player.runCommandAsync(`scoreboard players add @s zmc ${amount}`);
}

function subtractZMC(player, amount) {
    player.runCommandAsync(`scoreboard players remove @s zmc ${amount}`);
}

function giveItem(player, itemId, amount) {
    const inventory = player.getComponent("minecraft:inventory").container;
    inventory.addItem(new ItemStack(itemId, amount));
}

function removeItem(player, itemId, amount) {
    const inventory = player.getComponent("minecraft:inventory").container;
    let remaining = amount;

    for (let i = 0; i < inventory.size; i++) {
        const item = inventory.getItem(i);
        if (item && item.typeId === itemId) {
            if (item.amount > remaining) {
                item.amount -= remaining;
                inventory.setItem(i, item);
                return;
            } else {
                remaining -= item.amount;
                inventory.setItem(i, undefined);
            }
        }
    }
}

// Show Buy & Sell Menu
function showBuySellMenu(player) {
    const menu = new ActionFormData()
        .title("Shop")
        .body(`Your ZMC: ${getPlayerScore(player, "zmc")}`)
        .button("Buy Items")
        .button("Sell Items");

    menu.show(player).then(response => {
        if (response.canceled) return;

        if (response.selection === 0) {
            showItemsUI(player, "buy");
        } else if (response.selection === 1) {
            showItemsUI(player, "sell");
        }
    });
}

// Show Items UI
function showItemsUI(player, action, filteredItems = null) {
    const menu = new ActionFormData()
        .title(`${action === "buy" ? "Buy Items" : "Sell Items"}`)
        .body("Select an item:")
        .button("Search", "textures/ui/magnifyingGlass"); // Search button

    const itemsToDisplay = filteredItems || shopItems;

    itemsToDisplay.forEach(item => {
        menu.button(`${item.name}\n${action === "buy" ? `Cost: ${item.buyCost} ZMC` : `Sell: ${item.sellPrice} ZMC`}`, item.icon);
    });

    menu.show(player).then(response => {
        if (response.canceled) return;

        if (response.selection === 0) {
            // If "Search" button is selected
            showSearchUI(player, action);
        } else {
            // Item selection (adjusting for the search button index)
            const selectedItem = itemsToDisplay[response.selection - 1];
            if (selectedItem) {
                showAmountUI(player, action, selectedItem);
            }
        }
    });
}

// Search UI
function showSearchUI(player, action) {
    const modal = new ModalFormData()
        .title("Search Items")
        .textField("Enter item name:", "");

    modal.show(player).then(response => {
        if (response.canceled) return;

        const searchQuery = response.formValues[0].toLowerCase();
        const filteredItems = shopItems.filter(item => item.name.toLowerCase().includes(searchQuery));

        if (filteredItems.length > 0) {
            showItemsUI(player, action, filteredItems);
        } else {
            player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"No items found for '${searchQuery}'."}]}`);
            showItemsUI(player, action);
        }
    });
}

// Amount UI
function showAmountUI(player, action, item) {
    const modal = new ModalFormData()
        .title(`${action === "buy" ? "Buy" : "Sell"} ${item.name}`)
        .slider("Amount:", 1, 200, 1);

    modal.show(player).then(response => {
        if (response.canceled) return;

        const amount = response.formValues[0];
        if (action === "buy") {
            handleBuy(player, item, amount);
        } else if (action === "sell") {
            handleSell(player, item, amount);
        }
    });
}

// Handle Buying
function handleBuy(player, item, amount) {
    const totalCost = item.buyCost * amount;
    const playerZMC = getPlayerScore(player, "zmc");

    if (playerZMC >= totalCost) {
        subtractZMC(player, totalCost);
        giveItem(player, item.id, amount);
        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You bought ${amount}x ${item.name} for ${totalCost} ZMC!"}]}`);
    } else {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You don't have enough ZMC!"}]}`);
    }
}

// Handle Selling
function handleSell(player, item, amount) {
    const inventory = player.getComponent("minecraft:inventory").container;
    let itemCount = 0;

    for (let i = 0; i < inventory.size; i++) {
        const slotItem = inventory.getItem(i);
        if (slotItem && slotItem.typeId === item.id) {
            itemCount += slotItem.amount;
        }
    }

    if (itemCount >= amount) {
        const totalEarned = item.sellPrice * amount;
        removeItem(player, item.id, amount);
        addZMC(player, totalEarned);
        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You sold ${amount}x ${item.name} for ${totalEarned} ZMC!"}]}`);
    } else {
        player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"You don't have enough ${item.name} to sell!"}]}`);
    }
}

// Trigger the shop UI when the player uses a specific item (e.g., "zc:invshop")
world.afterEvents.itemUse.subscribe(event => {
    const { source, itemStack } = event;

    if (itemStack.typeId === "zc:invshop") {
        showBuySellMenu(source);
    }
});
