import { world, system } from "@minecraft/server";


function updateJetpackTags() {
    try {
        world.getDimension("overworld").runCommandAsync("tag @a remove jettte");
        world.getDimension("overworld").runCommandAsync("tag @a[hasitem={item=zc:simpl_jet,location=slot.armor.chest}] add jettte");
    } catch (error) {
        console.warn("Error updating jetpack tags:", error);
    }
}


function applyJetpackEffects() {
    for (const player of world.getPlayers()) {
        if (player.hasTag("jettte")) {
            const viewDirection = player.getViewDirection();
            
            if (viewDirection.y > 0.2) {
                player.runCommandAsync("effect @s levitation 1 1 true");
                player.runCommandAsync("effect @s slow_falling 15 1 true");
            } else if (viewDirection.y < -0.2) {
                player.runCommandAsync("effect @s slow_falling 10 1 true");
            }
        }
    }
}


system.runInterval(() => {
    updateJetpackTags();
    applyJetpackEffects();
}, 1);
