import { ActionFormData } from '@minecraft/server-ui';
import { world, system } from "@minecraft/server";

const ui = new ActionFormData()
  .title("Trash Can")
            .body("Do you want to clear it?")
            .button("Yes")
            .button("No");

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent('trash_can:trigger', {
    onPlayerInteract: e => {
      ui.show(e.player).then(response => {
        if (response.canceled) {
          e.player.runCommandAsync(``);
        } else {
          switch (response.selection) {
            case 0: 
              e.player.runCommandAsync('replaceitem entity @s slot.weapon.mainhand 0 air');
              break;
            case 1: 
              break;
          }
        }
      });
    },
  });
});


    

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
  initEvent.blockComponentRegistry.registerCustomComponent("zc_mbfilter:trigger", {
    onTick: (e) => {
      const block = e.block;
      if (!block) return;

      const blockLocation = block.location;
      const dimension = block.dimension;

      const x = blockLocation.x;
      const y = blockLocation.y;
      const z = blockLocation.z;

      dimension
        .runCommandAsync(`tag @e[type=creeper,x=${x},y=${y},z=${z},r=20] add mbf`)
        .catch((error) => console.warn("Error summoning piglin:", error));
        dimension
        .runCommandAsync(`tag @e[type=zombie,x=${x},y=${y},z=${z},r=20] add mbf`)
        .catch((error) => console.warn("Error summoning piglin:", error));
        dimension
        .runCommandAsync(`tag @e[type=skeleton,x=${x},y=${y},z=${z},r=20] add mbf`)
        .catch((error) => console.warn("Error summoning piglin:", error));
        dimension
        .runCommandAsync(`tag @e[type=spider,x=${x},y=${y},z=${z},r=20] add mbf`)
        .catch((error) => console.warn("Error summoning piglin:", error));
        
    },
  });
});






let timer = 0;

function mainTick() {

  timer++;


  if (timer === 15000) {
    world.getDimension("overworld").runCommand("function lc3");
  }


  if (timer === 21000) {
    world.getDimension("overworld").runCommand("function lc1");
  }


  if (timer === 22200) {
    world.getDimension("overworld").runCommand("function lc4");
    timer = 0;
  }

  system.run(mainTick);
}

system.run(mainTick);