import { world, system } from "@minecraft/server";


//hammer
world.afterEvents.itemUse.subscribe((data) => {
    const player = data.source;
    const item = data.itemStack;


    if (item?.typeId === "zc:hammer") {
        const location = player.location;

        const commands = [
            `fill ${Math.floor(location.x) - 3} ${Math.floor(location.y)} ${Math.floor(location.z) - 3} ${Math.floor(location.x) + 3} ${Math.floor(location.y) + 3} ${Math.floor(location.z) + 3} air 0 replace stone`,
            `fill ${Math.floor(location.x) - 3} ${Math.floor(location.y)} ${Math.floor(location.z) - 3} ${Math.floor(location.x) + 3} ${Math.floor(location.y) + 3} ${Math.floor(location.z) + 3} air 0 replace cobblestone`,
            `fill ${Math.floor(location.x) - 6} ${Math.floor(location.y)} ${Math.floor(location.z) - 6} ${Math.floor(location.x) + 6} ${Math.floor(location.y) + 6} ${Math.floor(location.z) + 6} air 0 replace gravel`,
            `fill ${Math.floor(location.x) - 6} ${Math.floor(location.y)} ${Math.floor(location.z) - 6} ${Math.floor(location.x) + 6} ${Math.floor(location.y) + 6} ${Math.floor(location.z) + 6} air 0 replace deepslate`,
            `fill ${Math.floor(location.x) - 6} ${Math.floor(location.y)} ${Math.floor(location.z) - 6} ${Math.floor(location.x) + 6} ${Math.floor(location.y) + 6} ${Math.floor(location.z) + 6} air 0 replace tuff`,
            `setblock ${Math.floor(location.x)} ${Math.floor(location.y)} ${Math.floor(location.z)} torch keep`,
            `fill ${Math.floor(location.x) - 6} ${Math.floor(location.y)} ${Math.floor(location.z) - 6} ${Math.floor(location.x) + 6} ${Math.floor(location.y) + 6} ${Math.floor(location.z) + 6} air 0 replace dirt`,
            `fill ${Math.floor(location.x) - 6} ${Math.floor(location.y)} ${Math.floor(location.z) - 6} ${Math.floor(location.x) + 6} ${Math.floor(location.y) + 6} ${Math.floor(location.z) + 6} air 0 replace gravel`
        ];
        commands.forEach((command) => {
            player.dimension.runCommandAsync(command);
        });

        player.addEffect("mining_fatigue", 20, {
            amplifier: 3,
            showParticles: false
        });
        player.addEffect("hunger", 20, {
            amplifier: 3,
            showParticles: false
        });
    }
});

//Nether Hammer

world.afterEvents.itemUse.subscribe((data) => {
    const player = data.source;
    const item = data.itemStack;

    // Check if the used item is "zc:nether_hammer"
    if (item?.typeId === "zc:nether_hammer") {
        const location = player.location;

        // Commands to execute
        const commands = [
            `fill ${Math.floor(location.x) - 6} ${Math.floor(location.y)} ${Math.floor(location.z) - 6} ${Math.floor(location.x) + 6} ${Math.floor(location.y) + 6} ${Math.floor(location.z) + 6} air 0 replace netherrack`,
            `fill ${Math.floor(location.x) - 8} ${Math.floor(location.y)} ${Math.floor(location.z) - 8} ${Math.floor(location.x) + 8} ${Math.floor(location.y) + 8} ${Math.floor(location.z) + 8} air 0 replace lava`,
            `setblock ${Math.floor(location.x)} ${Math.floor(location.y)} ${Math.floor(location.z)} torch keep`,
            `fill ${Math.floor(location.x) - 6} ${Math.floor(location.y)} ${Math.floor(location.z) - 6} ${Math.floor(location.x) + 6} ${Math.floor(location.y) + 6} ${Math.floor(location.z) + 6} air 0 replace blackstone`,
            `fill ${Math.floor(location.x) - 6} ${Math.floor(location.y)} ${Math.floor(location.z) - 6} ${Math.floor(location.x) + 6} ${Math.floor(location.y) + 6} ${Math.floor(location.z) + 6} air 0 replace gravel`
        ];

        // Execute commands in the player's dimension
        commands.forEach((command) => {
            player.dimension.runCommandAsync(command);
        });

        // Apply effects to the player
        player.addEffect("minecraft:mining_fatigue", 20, {
            amplifier: 3,
            showParticles: false
        });
        player.addEffect("minecraft:hunger", 20, {
            amplifier: 3,
            showParticles: false
        });
    }
});


//4Hammer
function durabilityOnChanged(item, player, isHitEntity = false) {
    let level = item.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level;

    function durability() {
        let durability = item.getComponent("minecraft:durability");

        const t = Math.floor(Math.random() * 100);

        if (t < durability.getDamageChance()) {
            if (!isHitEntity) durability.damage += 1;
            if (durability.damage >= durability.maxDurability) {
                player.playSound("random.break");
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', undefined)
            } else {
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item)
            }
        } else {
            if (!isHitEntity) return;
            durability.damage -= 1;
            if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }

    const t = Math.floor(Math.random() * 10)
    if (level === 1 && t > 8) return;
    else if (level === 2 && t > 6) return;
    else if (level === 3 && t > 4) return;
    else durability();
}

world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('zc_pick4:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("fill ~-1~~-1~1~2~1 air destroy"); },
  onUseOn: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("fill ~-1~~-1~1~2~1 air destroy"); },
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});
 });
