import { world } from "@minecraft/server";

world.afterEvents.playerPlaceBlock.subscribe((event) => {
    const player = event.player; 
    const block = event.block;
    const blockPos = block.location;

    
    if (block.typeId === "zc:teleport_stone1") {
        player.runCommandAsync(
            `setblock ${blockPos.x} ${blockPos.y + 1} ${blockPos.z} zc:teleport_stone2`
        );
    }
});

world.afterEvents.playerBreakBlock.subscribe(async (event) => {
    const { player, brokenBlockPermutation } = event;
    const blockPos = event.block.location;

    if (brokenBlockPermutation.type.id === "zc:teleport_stone2") {
        try {
            await player.runCommandAsync(
                `setblock ${blockPos.x} ${blockPos.y - 1} ${blockPos.z} air destroy`
            );
        } catch (error) {
            console.warn(`Failed to execute command: ${error}`);
        }
    }
});
