import { world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";

world.afterEvents.itemUse.subscribe(event => {
    const { source, itemStack } = event;
    
    if (source.typeId !== "minecraft:player") return; 
    
    if (itemStack.typeId === "zc:bandage") {
        
        const firstAidCraftUI = new ActionFormData()
            .title("First Aid Craft") 
            .body("Choose To Heal, it's beta version") 
            .button("Head") 
            .button("Body") 
            .button("Hands") 
            .button("Legs"); 
        
        firstAidCraftUI.show(source).then(response => {
            
            if (response.canceled) return; 
            
            if (response.selection !== null) {  
                source.runCommand("effect @s regeneration 20 0 true");
                source.runCommand("clear @s zc:bandage 0 1");
                source.runCommand("playsound ui.cartography_table.take_result @s");
            }
        }).catch(error => {
            console.error("Error displaying the UI: ", error);
        });
    }
});




world.afterEvents.itemUse.subscribe(event => {
    const { source, itemStack } = event;
    
    if (source.typeId !== "minecraft:player") return; 
    
    if (itemStack.typeId === "zc:madkit") {
        
        const firstAidCraftUI = new ActionFormData()
            .title("First Aid Craft") 
            .body("Choose To Heal, it's beta version") 
            .button("Head") 
            .button("Body") 
            .button("Hands") 
            .button("Legs"); 
        
        firstAidCraftUI.show(source).then(response => {
            
            if (response.canceled) return; 
            
            if (response.selection !== null) {  
                source.runCommand("effect @s regeneration 20 1 true");
                source.runCommand("clear @s zc:madkit 0 1");
                source.runCommand("playsound ui.cartography_table.take_result @s");
            }
        }).catch(error => {
            console.error("Error displaying the UI: ", error);
        });
    }
});





world.afterEvents.itemUse.subscribe(event => {
    const { source, itemStack } = event;
    
    if (source.typeId !== "minecraft:player") return; 
    
    if (itemStack.typeId === "zc:gmadkit") {
        
        const firstAidCraftUI = new ActionFormData()
            .title("First Aid Craft") 
            .body("Choose To Heal, it's beta version") 
            .button("Head") 
            .button("Body") 
            .button("Hands") 
            .button("Legs"); 
        
        firstAidCraftUI.show(source).then(response => {
            
            if (response.canceled) return; 
            
            if (response.selection !== null) {  
                source.runCommand("effect @s regeneration 20 2 true");
                source.runCommand("effect @s absorption 180 3 true");
                source.runCommand("clear @s zc:gmadkit 0 1");
                source.runCommand("playsound ui.cartography_table.take_result @s");
            }
        }).catch(error => {
            console.error("Error displaying the UI: ", error);
        });
    }
});





