import { world, system } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";

let quests = [
    { id: 0, title: "Collect Oak Logs", item: ["minecraft:oak_log"], amount: 10 },
    { id: 1, title: "Collect Cobblestone", item: ["minecraft:cobblestone"], amount: 15 },
    { id: 2, title: "Collect Coal", item: ["minecraft:coal"], amount: 10 },
    { id: 3, title: "Collect Iron Ore", item: ["minecraft:iron_ore"], amount: 10 },
    { id: 4, title: "Collect Iron Ingots", item: ["minecraft:iron_ingot"], amount: 5 },
    { id: 5, title: "Collect Gold Ore", item: ["minecraft:gold_ore"], amount: 5 },
    { id: 6, title: "Collect Redstone", item: ["minecraft:redstone"], amount: 10 },
    { id: 7, title: "Collect Lapis Lazuli", item: ["minecraft:lapis_lazuli"], amount: 10 },
    { id: 8, title: "Collect Diamonds", item: ["minecraft:diamond"], amount: 3 },
    { id: 9, title: "Collect Obsidian", item: ["minecraft:obsidian"], amount: 4 },
    { id: 10, title: "Collect Flint", item: ["minecraft:flint"], amount: 5 },
    { id: 11, title: "Collect Clay Balls", item: ["minecraft:clay_ball"], amount: 10 },
    { id: 12, title: "Collect Bricks", item: ["minecraft:brick"], amount: 10 },
    { id: 13, title: "Collect Sand", item: ["minecraft:sand"], amount: 10 },
    { id: 14, title: "Collect Glass", item: ["minecraft:glass"], amount: 5 },
    { id: 15, title: "Collect Gravel", item: ["minecraft:gravel"], amount: 10 },
    { id: 16, title: "Collect Sugarcane", item: ["minecraft:sugar_cane"], amount: 10 },
    { id: 17, title: "Collect Paper", item: ["minecraft:paper"], amount: 5 },
    { id: 18, title: "Collect Leather", item: ["minecraft:leather"], amount: 5 },
    { id: 19, title: "Collect Books", item: ["minecraft:book"], amount: 3 },
    { id: 20, title: "Collect Bookshelves", item: ["minecraft:bookshelf"], amount: 3 },
    { id: 21, title: "Collect Enchanting Table", item: ["minecraft:enchanting_table"], amount: 1 },
    { id: 22, title: "Collect Anvil", item: ["minecraft:anvil"], amount: 1 },
    { id: 23, title: "Collect Emeralds", item: ["minecraft:emerald"], amount: 5 },
    { id: 24, title: "Collect Golden Apples", item: ["minecraft:golden_apple"], amount: 2 },
    { id: 25, title: "Collect Enchanted Golden Apple", item: ["minecraft:enchanted_golden_apple"], amount: 1 },
    { id: 26, title: "Collect Totem of Undying", item: ["minecraft:totem_of_undying"], amount: 1 },
    { id: 27, title: "Collect Ender Pearls", item: ["minecraft:ender_pearl"], amount: 5 },
    { id: 28, title: "Collect Ender Chest", item: ["minecraft:ender_chest"], amount: 1 },
    { id: 29, title: "Collect Heart of the Sea", item: ["minecraft:heart_of_the_sea"], amount: 1 },
    { id: 30, title: "Collect Conduit", item: ["minecraft:conduit"], amount: 1 },
    { id: 31, title: "Collect Turtle Shell", item: ["minecraft:turtle_helmet"], amount: 1 },
    { id: 32, title: "Collect Trident", item: ["minecraft:trident"], amount: 1 },
    { id: 33, title: "Collect Netherrack", item: ["minecraft:netherrack"], amount: 15 },
    { id: 34, title: "Collect Soul Sand", item: ["minecraft:soul_sand"], amount: 10 },
    { id: 35, title: "Collect Nether Quartz", item: ["minecraft:quartz"], amount: 10 },
    { id: 36, title: "Collect Glowstone Dust", item: ["minecraft:glowstone_dust"], amount: 10 },
    { id: 37, title: "Collect Magma Blocks", item: ["minecraft:magma_block"], amount: 5 },
    { id: 38, title: "Collect Nether Bricks", item: ["minecraft:nether_brick"], amount: 10 },
    { id: 39, title: "Collect Blaze Rods", item: ["minecraft:blaze_rod"], amount: 5 },
    { id: 40, title: "Collect Nether Wart", item: ["minecraft:nether_wart"], amount: 10 },
    { id: 41, title: "Collect Wither Skeleton Skull", item: ["minecraft:wither_skeleton_skull"], amount: 1 },
    { id: 42, title: "Collect Ancient Debris", item: ["minecraft:ancient_debris"], amount: 3 },
    { id: 43, title: "Collect Netherite Scrap", item: ["minecraft:netherite_scrap"], amount: 3 },
    { id: 44, title: "Collect Netherite Ingot", item: ["minecraft:netherite_ingot"], amount: 1 },
    { id: 45, title: "Collect Netherite Upgrade Smithing Template", item: ["minecraft:netherite_upgrade_smithing_template"], amount: 1 },
    { id: 46, title: "Collect Piglin Bartered Items", item: ["minecraft:ender_pearl", "minecraft:crying_obsidian", "minecraft:gravel"], amount: 5 },
    { id: 47, title: "Collect Bastion Loot (Gold Block)", item: ["minecraft:gold_block"], amount: 1 },
    { id: 48, title: "Collect Pigstep Music Disc", item: ["minecraft:music_disc_pigstep"], amount: 1 },
    { id: 49, title: "Collect Netherite Armor Piece", item: ["minecraft:netherite_chestplate", "minecraft:netherite_helmet", "minecraft:netherite_leggings", "minecraft:netherite_boots"], amount: 1 },
    { id: 50, title: "Collect Nether Star", item: ["minecraft:nether_star"], amount: 1 },
    { id: 51, title: "Collect End Stone", item: ["minecraft:end_stone"], amount: 10 },
    { id: 52, title: "Collect Chorus Fruit", item: ["minecraft:chorus_fruit"], amount: 5 },
    { id: 53, title: "Collect Popped Chorus Fruit", item: ["minecraft:popped_chorus_fruit"], amount: 5 },
    { id: 54, title: "Collect Ender Pearls", item: ["minecraft:ender_pearl"], amount: 5 },
    { id: 55, title: "Collect Dragon’s Breath", item: ["minecraft:dragon_breath"], amount: 3 },
    { id: 56, title: "Collect Shulker Shells", item: ["minecraft:shulker_shell"], amount: 4 },
    { id: 57, title: "Collect Purpur Blocks", item: ["minecraft:purpur_block"], amount: 10 },
    { id: 58, title: "Collect End Rods", item: ["minecraft:end_rod"], amount: 5 },
    { id: 59, title: "Collect Elytra", item: ["minecraft:elytra"], amount: 1 },
    { id: 60, title: "Collect Dragon Head", item: ["minecraft:dragon_head"], amount: 1 },
    { id: 61, title: "Collect End Gateway Crystals", item: ["minecraft:end_crystal"], amount: 2 },
    { id: 62, title: "Collect Ender Chest", item: ["minecraft:ender_chest"], amount: 1 },
    { id: 63, title: "Collect Dragon Egg", item: ["minecraft:dragon_egg"], amount: 1 }
];

let rewards = [
    { item: "minecraft:apple", amount: 3 },
    { item: "minecraft:stone", amount: 10 },
    { item: "minecraft:coal", amount: 5 },
    { item: "minecraft:iron_nugget", amount: 4 },
    { item: "minecraft:bread", amount: 3 },
    { item: "minecraft:iron_ingot", amount: 2 },
    { item: "minecraft:gold_nugget", amount: 6 },
    { item: "minecraft:emerald", amount: 1 },
    { item: "minecraft:experience_bottle", amount: 2 },
    { item: "minecraft:lapis_lazuli", amount: 5 },
    { item: "minecraft:redstone", amount: 4 },
    { item: "minecraft:gold_ingot", amount: 2 },
    { item: "minecraft:blaze_powder", amount: 2 },
    { item: "minecraft:glowstone_dust", amount: 3 },
    { item: "minecraft:ender_pearl", amount: 1 },
    { item: "minecraft:quartz", amount: 6 },
    { item: "minecraft:magma_cream", amount: 2 },
    { item: "minecraft:nether_brick", amount: 4 },
    { item: "minecraft:ghast_tear", amount: 1 },
    { item: "minecraft:crying_obsidian", amount: 2 },
    { item: "minecraft:shulker_shell", amount: 1 },
    { item: "minecraft:chorus_fruit", amount: 3 },
    { item: "minecraft:diamond", amount: 1 }
];

function getPlayerScore(player, objective) {
    try {
        return world.scoreboard.getObjective(objective).getScore(player) || 0;
    } catch {
        return 0;
    }
}

function setPlayerScore(player, objective, value) {
    player.runCommand(`scoreboard players set @s ${objective} ${value}`);
}

function playSound(player, sound) {
    player.runCommand(`playsound ${sound} @s ~~~ 1 1 1`);
}

function checkQuestCompletion(player, quest) {
    let count = 0;
    let inventory = player.getComponent("minecraft:inventory").container;

    for (let i = 0; i < inventory.size; i++) {
        let item = inventory.getItem(i);
        if (item && quest.item.includes(item.typeId)) {
            count += item.amount;
        }
    }

    return count >= quest.amount;
}

function giveRandomReward(player) {
    let reward = rewards[Math.floor(Math.random() * rewards.length)];
    player.runCommand(`give @s ${reward.item} ${reward.amount}`);
    player.sendMessage(`§6[Quest]§r You received: §a${reward.amount}x ${reward.item.replace("minecraft:", "").toUpperCase()}!`);
}

function processQuest(player) {
    let vanillaq = getPlayerScore(player, "vanillaq");

    if (vanillaq < quests.length) {
        let currentQuest = quests[vanillaq];

        if (checkQuestCompletion(player, currentQuest)) {
            setPlayerScore(player, "vanillaq", vanillaq + 1);
            giveRandomReward(player);
            playSound(player, "random.levelup");
            player.runCommand(`execute @a[scores={vanillaq=${vanillaq}}] ~~~ tellraw @a {"rawtext":[{"text":"§6[Quest]§r Quest Completed: §a${currentQuest.title}"}]}`);

            if (vanillaq + 1 < quests.length) {
                let nextQuest = quests[vanillaq + 1];
                player.runCommand(`execute @a[scores={vanillaq=${vanillaq + 1}}] ~~~ tellraw @a {"rawtext":[{"text":"§6[Quest]§r Next Quest: §e${nextQuest.title}, §dAmount- §r${nextQuest.amount}"}]}`);
            }
        }
    }
}

function showQuestUI(player) {
    let vanillaq = getPlayerScore(player, "vanillaq");
    let form = new ActionFormData();
    form.title("§6Vanilla Quest Menu");
    form.body("Select a quest to check progress:");

    for (let quest of quests) {
        let status = vanillaq > quest.id ? "§2√ Completed" : vanillaq === quest.id ? "§e=> Current" : "§4★Locked";
        form.button(`${quest.title}\n${status}`);
    }

    form.show(player).then(response => {
        if (response.canceled) return;
        playSound(player, "ui.toast.challenge_complete");

        let selectedQuest = quests[response.selection];
        if (vanillaq > selectedQuest.id) {
            player.sendMessage(`§6[Quest]§r You have already completed: §a${selectedQuest.title}`);
        } else if (vanillaq === selectedQuest.id) {
            player.sendMessage(`§6[Quest]§r: §e${selectedQuest.title}, §dAmount §r${selectedQuest.amount}`);
        } else {
            player.sendMessage(`§6[Quest]§r This quest is locked! Complete previous quests first.`);
        }
    });
}

world.afterEvents.itemUse.subscribe(event => {
    let player = event.source;
    let item = event.itemStack;
    if (item && item.typeId === "zc:vanilla_quest") {
        showQuestUI(player);
    }
});

system.runInterval(() => {
    for (let player of world.getPlayers()) {
        processQuest(player);
    }
}, 20);
