import { ActionFormData } from '@minecraft/server-ui';
import { world } from '@minecraft/server';


function showVanillaUI(player) {
    if (player.level < 25) {
        player.sendMessage("§cYou need at least 25 XP levels to access Vanilla Enchantments!");
        return;
    }

    const ui = new ActionFormData()
        .title("§l§4Vanilla Enchantment")
        .body("§l§6Minimum 25 Level Required")
        .button("§l§5Sharpness V", "textures/items/book_enchanted")
        .button("§l§5Looting III", "textures/items/book_enchanted")
        .button("§l§5Unbreaking III", "textures/items/book_enchanted")
        .button("§l§5Protection IV", "textures/items/book_enchanted")
        .button("§l§5Depth Strider III", "textures/items/book_enchanted")
        .button("§l§5Feather Falling IV", "textures/items/book_enchanted")
        .button("§l§5Frost Walker II", "textures/items/book_enchanted")
        .button("§l§5Respiration III", "textures/items/book_enchanted")
        .button("§l§5Soul Speed III", "textures/items/book_enchanted")
        .button("§l§5Thorns III", "textures/items/book_enchanted")
        .button("§l§5Swift Sneak III", "textures/items/book_enchanted")
        .button("§l§5Efficiency V", "textures/items/book_enchanted")
        .button("§l§5Fire Aspect II", "textures/items/book_enchanted")
        .button("§l§5Infinity I", "textures/items/book_enchanted")
        .button("§l§5Silk Touch", "textures/items/book_enchanted")
        .button("§l§5Fortune III", "textures/items/book_enchanted")
        .button("§l§5Mending", "textures/items/book_enchanted")
        .button("§l§5Wind Burst III", "textures/items/book_enchanted");

    ui.show(player).then(response => {
        if (!response.canceled) {
            const enchantments = [
                "sharpness 5", "looting 3", "unbreaking 3", "protection 4", "depth_strider 3",
                "feather_falling 4", "frost_walker 2", "respiration 3", "soul_speed 3", "thorns 3",
                "swift_sneak 3", "efficiency 5", "fire_aspect 2", "infinity", "silk_touch",
                "fortune 3", "mending", "wind_burst 3"
            ];
            player.runCommandAsync(`enchant @p[lm=25] ${enchantments[response.selection]}`);
            player.runCommandAsync(`xp -3l @s`);
        }
    });
}


function showAdvancedVanillaUI(player) {
    if (player.level < 50) {
        player.sendMessage("§cYou need at least 50 XP levels to access Advanced Enchantments!");
        return;
    }

    const ui = new ActionFormData()
        .title("§l§4Advanced Enchantments")
        .body("§l§6Minimum 50 Level Required")
        .button("§l§5Unbreaking V", "textures/items/book_enchanted")
        .button("§l§5Looting V", "textures/items/book_enchanted")
        .button("§l§5Respiration V", "textures/items/book_enchanted")
        .button("§l§5Thorns V", "textures/items/book_enchanted")
        .button("§l§5Fortune V", "textures/items/book_enchanted")
        .button("§l§5Protection VI", "textures/items/book_enchanted")
        .button("§l§5Power VII", "textures/items/book_enchanted")
        .button("§l§5Sharpness VII", "textures/items/book_enchanted")
        .button("§l§5Efficiency VII", "textures/items/book_enchanted")
        .button("§l§5Feather Falling VII", "textures/items/book_enchanted")
        .button("§l§5Lure V", "textures/items/book_enchanted")
        .button("§l§5Quick Charge IV", "textures/items/book_enchanted")
        .button("§l§5Punch III", "textures/items/book_enchanted")
        .button("§l§5Depth Strider V", "textures/items/book_enchanted")
        .button("§l§5Knockback III", "textures/items/book_enchanted")
        .button("§l§5Luck of the Sea V", "textures/items/book_enchanted");

    ui.show(player).then(response => {
        if (!response.canceled) {
            const structures = [
                "unbreaking5", "looting5", "respiration5", "thorns5", "fortune5",
                "protection6", "power7", "sharpness7", "efficiency7", "featherfalling7",
                "lure5", "quickcharge4", "punch3", "depthstrider5", "knockback3", "luckofthesea5"
            ];
            player.runCommandAsync(`structure load ${structures[response.selection]} ~~1~`);
            player.runCommandAsync(`xp -10l @s`);
        }
    });
}


function showOverEnchantmentUI(player) {
    if (player.level < 75) {
        player.sendMessage("§cYou need at least 75 XP levels to access Over Enchantments!");
        return;
    }

    const ui = new ActionFormData()
        .title("§l§4Over Enchantments")
        .body("§l§6Minimum 75 XP Levels Required")
        .button("§l§5Unbreaking X", "textures/items/book_enchanted")
        .button("§l§5Thorns X", "textures/items/book_enchanted")
        .button("§l§5Fortune X", "textures/items/book_enchanted")
        .button("§l§5Protection X", "textures/items/book_enchanted")
        .button("§l§5Power X", "textures/items/book_enchanted")
        .button("§l§5Sharpness X", "textures/items/book_enchanted")
        .button("§l§5Efficiency X", "textures/items/book_enchanted")
        .button("§l§5Feather Falling X", "textures/items/book_enchanted");

    ui.show(player).then(response => {
        if (!response.canceled) {
            const structures = [
                "unbreaking10", "thorns10", "fortune10", "protection10",
                "power10", "sharpness10", "efficiency10", "featherfalling10"
            ];
            player.runCommandAsync(`structure load ${structures[response.selection]} ~~1~`);
            player.runCommandAsync(`xp -20l @s`);
        }
    });
}


function showMainUI(player) {
    const ui = new ActionFormData()
        .title("§l§bEnchantment Selection")
        .body("§l§6Choose an enchantment category")
        .button("§l§5Vanilla Enchantment")
        .button("§l§5Advanced Enchantment")
        .button("§l§5Over Enchantment");

    ui.show(player).then(response => {
        if (!response.canceled) {
            switch (response.selection) {
                case 0:
                    showVanillaUI(player);
                    break;
                case 1:
                    showAdvancedVanillaUI(player);
                    break;
                case 2:
                    showOverEnchantmentUI(player);
                    break;
            }
        }
    });
}

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('zc_aetb:trigger', {
        onPlayerInteract: e => {
            showMainUI(e.player);
        },
    });
});
