import { world } from "@minecraft/server";
import { ModalFormData } from "@minecraft/server-ui";

function showUI(player) {

    const isTurnedOn = player.hasTag("vshi");

    const ui = new ModalFormData()
        .title("§l§4Void Shield")
        .toggle("End Mode", isTurnedOn); 
        
    ui.show(player).then(response => {
        const toggleState = response.formValues[0]; 

        if (toggleState && !isTurnedOn) {
            enableVoidShield(player); 
        } else if (!toggleState && isTurnedOn) {
            disableVoidShield(player); 
        }
    });
}

function enableVoidShield(player) {
    
    if (player.hasTag("vshi")) return;

    player.addTag("vshi"); 
    player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§aEnd Mode is Enabled!"}]}`); 
}

function disableVoidShield(player) {
    
    if (!player.hasTag("vshi")) return;

    player.removeTag("vshi"); 
    player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cEnd Mode is Disabled!"}]}`); 
}

world.afterEvents.itemUse.subscribe((event) => {
    const { source, itemStack } = event;
    if (itemStack.typeId === "zc:vshied") {
        showUI(source); 
    }
});

world.beforeEvents.playerLeave.subscribe((event) => {
    const player = event.player;
    if (player.hasTag("vshi")) {
        disableVoidShield(player); 
    }
});
